<?php

namespace App|C\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CreateTicketResponse StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:CreateTicketResponse
 * @subpackage Structs
 */
class CreateTicketResponse extends AbstractResponse
{
    /**
     * The CreateTicketResult
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \App|C\StructType\CreateTicketResponse
     */
    public $CreateTicketResult;
    /**
     * The Booking
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \App|C\StructType\Booking
     */
    public $Booking;
    /**
     * The RedirectResult
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \App|C\StructType\FormOfPaymentRedirectResult
     */
    public $RedirectResult;
    /**
     * Constructor method for CreateTicketResponse
     * @uses CreateTicketResponse::setCreateTicketResult()
     * @uses CreateTicketResponse::setBooking()
     * @uses CreateTicketResponse::setRedirectResult()
     * @param \App|C\StructType\CreateTicketResponse $createTicketResult
     * @param \App|C\StructType\Booking $booking
     * @param \App|C\StructType\FormOfPaymentRedirectResult $redirectResult
     */
    public function __construct(\App|C\StructType\CreateTicketResponse $createTicketResult = null, \App|C\StructType\Booking $booking = null, \App|C\StructType\FormOfPaymentRedirectResult $redirectResult = null)
    {
        $this
            ->setCreateTicketResult($createTicketResult)
            ->setBooking($booking)
            ->setRedirectResult($redirectResult);
    }
    /**
     * Get CreateTicketResult value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \App|C\StructType\CreateTicketResponse|null
     */
    public function getCreateTicketResult()
    {
        return isset($this->CreateTicketResult) ? $this->CreateTicketResult : null;
    }
    /**
     * Set CreateTicketResult value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \App|C\StructType\CreateTicketResponse $createTicketResult
     * @return \App|C\StructType\CreateTicketResponse
     */
    public function setCreateTicketResult(\App|C\StructType\CreateTicketResponse $createTicketResult = null)
    {
        if (is_null($createTicketResult) || (is_array($createTicketResult) && empty($createTicketResult))) {
            unset($this->CreateTicketResult);
        } else {
            $this->CreateTicketResult = $createTicketResult;
        }
        return $this;
    }
    /**
     * Get Booking value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \App|C\StructType\Booking|null
     */
    public function getBooking()
    {
        return isset($this->Booking) ? $this->Booking : null;
    }
    /**
     * Set Booking value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \App|C\StructType\Booking $booking
     * @return \App|C\StructType\CreateTicketResponse
     */
    public function setBooking(\App|C\StructType\Booking $booking = null)
    {
        if (is_null($booking) || (is_array($booking) && empty($booking))) {
            unset($this->Booking);
        } else {
            $this->Booking = $booking;
        }
        return $this;
    }
    /**
     * Get RedirectResult value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \App|C\StructType\FormOfPaymentRedirectResult|null
     */
    public function getRedirectResult()
    {
        return isset($this->RedirectResult) ? $this->RedirectResult : null;
    }
    /**
     * Set RedirectResult value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \App|C\StructType\FormOfPaymentRedirectResult $redirectResult
     * @return \App|C\StructType\CreateTicketResponse
     */
    public function setRedirectResult(\App|C\StructType\FormOfPaymentRedirectResult $redirectResult = null)
    {
        if (is_null($redirectResult) || (is_array($redirectResult) && empty($redirectResult))) {
            unset($this->RedirectResult);
        } else {
            $this->RedirectResult = $redirectResult;
        }
        return $this;
    }
}
