<?php

namespace App|C\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for LoadBookingResponse StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:LoadBookingResponse
 * @subpackage Structs
 */
class LoadBookingResponse extends AbstractResponse
{
    /**
     * The LoadBookingResult
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \App|C\StructType\LoadBookingResponse
     */
    public $LoadBookingResult;
    /**
     * The Booking
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \App|C\StructType\Booking
     */
    public $Booking;
    /**
     * Constructor method for LoadBookingResponse
     * @uses LoadBookingResponse::setLoadBookingResult()
     * @uses LoadBookingResponse::setBooking()
     * @param \App|C\StructType\LoadBookingResponse $loadBookingResult
     * @param \App|C\StructType\Booking $booking
     */
    public function __construct(\App|C\StructType\LoadBookingResponse $loadBookingResult = null, \App|C\StructType\Booking $booking = null)
    {
        $this
            ->setLoadBookingResult($loadBookingResult)
            ->setBooking($booking);
    }
    /**
     * Get LoadBookingResult value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \App|C\StructType\LoadBookingResponse|null
     */
    public function getLoadBookingResult()
    {
        return isset($this->LoadBookingResult) ? $this->LoadBookingResult : null;
    }
    /**
     * Set LoadBookingResult value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \App|C\StructType\LoadBookingResponse $loadBookingResult
     * @return \App|C\StructType\LoadBookingResponse
     */
    public function setLoadBookingResult(\App|C\StructType\LoadBookingResponse $loadBookingResult = null)
    {
        if (is_null($loadBookingResult) || (is_array($loadBookingResult) && empty($loadBookingResult))) {
            unset($this->LoadBookingResult);
        } else {
            $this->LoadBookingResult = $loadBookingResult;
        }
        return $this;
    }
    /**
     * Get Booking value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \App|C\StructType\Booking|null
     */
    public function getBooking()
    {
        return isset($this->Booking) ? $this->Booking : null;
    }
    /**
     * Set Booking value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \App|C\StructType\Booking $booking
     * @return \App|C\StructType\LoadBookingResponse
     */
    public function setBooking(\App|C\StructType\Booking $booking = null)
    {
        if (is_null($booking) || (is_array($booking) && empty($booking))) {
            unset($this->Booking);
        } else {
            $this->Booking = $booking;
        }
        return $this;
    }
}
